<template>
  <div>
    <b-card title="Login" bg-variant="light">
      <b-alert show  v-if="erro !== ''" variant="danger">{{erro}}</b-alert>
      <b-form @submit="onSubmit" v-if="show">
          <b-form-group
              id="email-group"
          >
              <b-form-input
              id="email"
              v-model="form.email"
              type="email"    
              required
              placeholder="Email"
              ></b-form-input>
          </b-form-group>
          <b-form-group
              id="senha-group"
          >
              <b-form-input
              id="senha"
              v-model="form.senha"
              type="password"
              required
              placeholder="Senha"
              ></b-form-input>
          </b-form-group>
          
          <b-button squared  type="submit" variant="primary" class="center-block">Entrar</b-button>                    
      </b-form>
    </b-card>
  </div>
</template>

<script>

  export default {
    data() {
      return {
        form: {
          email: '',
          senha: '',
        },
        erro: '',
        show: true
      }
    },
    methods: {
      onSubmit(event) {
        event.preventDefault()
        this.$store.dispatch('efetuarLogin', this.form)
          .then(() => {this.$router.push('/auth')})
          .catch(err => this.tratarErro(err))
      },
      tratarErro(err){
        if(err.response) {
          const dataError=err.response.data

          const mensagemErro = dataError.error_description;
          if( mensagemErro === 'Bad credentials') { 
            this.erro = 'Usuário ou senha incorreta'
          } else if(mensagemErro === 'User is disabled') {
            this.erro = 'Usuário inativo. Entre em contato com o administrador do sistema';
          } else {
            this.erro = mensagemErro;
          }          
        } else {
          this.erro='Erro desconhecido'
        }
      }
    }
  }
</script>